#!/usr/bin/perl

$GROUP_RPM      = "./MailWebServer_UpdateRPM.tgz";
$LOG_FILE	= "/var/log/patchpop1.log";
$HTTPDCONF      = "/etc/httpd/conf/httpd.conf";
$HTTPDBOOT      = "/etc/httpd/conf/httpd.bootopt";
$ROTATE_APACHE  = "/etc/logrotate.d/apache";
$FILELIST       = "./InstallFileList.txt";
$APACHE_RPM     = "httpd-2.0.46-44.ent.i386.rpm";
$CRON_RPM       = "vixie-cron-3.0.1-74.73.i386.rpm";
$MODSSL_RPM     = "mod_ssl-2.8.12-5.73.i386.rpm";
$SENDMAIL_RPM   = "sendmail-8.11.6-12.1.i386.rpm";
$MGETTY_RPM     = "mgetty-1.1.30-0.7.i386.rpm";
$OPENLDAP_RPM   = "openldap-servers-2.0.27-2.7.3.i386.rpm";
$OPENSSH_C_RPM  = "openssh-clients-3.1p1-14.1.i386.rpm";
$OPENSSH_S_RPM  = "openssh-server-3.1p1-14.1.i386.rpm";

print "\n---Script Start-----\n\n";
if(!-e $GROUP_RPM){
  print "No such file : $GROUP_RPM\n";
  return 1;
}
if(!open(IN,"/bin/tar -xzf $GROUP_RPM |")){
  print "Update Failed.($rpmname)\n";
  return 1;
}
close(IN);

@HB_fileP=();
if($ARGV[0] eq ""){
#  if(-e "$HTTPDBOOT")  { &readFile($HTTPDBOOT,*HB_fileP)};
#  system("/bin/cp -arf /etc/mail/sendmail.cw ./wbmc_rpm/ > /dev/null 2>&1");
  &AllInstall();

  ## Rel 1.12
  ## system("/bin/cp -arf ./wbmc_rpm/httpd /etc/rc.d/init.d/httpd > /dev/null 2>&1");
  ##

#  if(-e "$HTTPDBOOT")  { &writeFile($HTTPDBOOT,*HB_fileP)};
#  system("/bin/cp -arf ./wbmc_rpm/sendmail.cw /etc/mail/sendmail.cw > /dev/null 2>&1");
}
elsif($ARGV[0] eq "-A"){
  &readFile($HTTPDBOOT,*HB_fileP);
  &ApacheInstall("apache-1.3.19-5.i386.rpm");
  &UpdateRPM("apache-devel-1.3.19-5.i386.rpm");
  &UpdateRPM("apache-manual-1.3.19-5.i386.rpm");
  &InstallRPM("mod_ssl-2.8.3-5.i386.rpm");
  &writeFile($HTTPDBOOT,*HB_fileP);
}
elsif($ARGV[0] eq "-V"){
  if(UpdateRPM("vixie-cron-3.0.1-48.i386.rpm") == 0){
    if(-e "/etc/logrotate.d/cron.rpmsave"){
      system("/bin/mv /etc/logrotate.d/cron.rpmsave /etc/logrotate.d/cron > /dev/null 2>&1");
    }
  }
}
elsif($ARGV[0] eq "-D"){
 if(-d "./wbmc_rpm"){
   system("/bin/rm -rf ./wbmc_rpm > /dev/null 2>&1");
   print "Delete Sccessful.(./wbmc_rpm)\n";
 }
}
else{
  print "Invalid Option.";
}
if(-d "./wbmc_rpm"){
  system("/bin/rm -rf ./wbmc_rpm > /dev/null 2>&1");
}

system("/bin/date >> $LOG_FILE");
system("/bin/rpm -qa >> $LOG_FILE");
print "\n---Script End-----\n";
exit 0;


sub AllInstall
{
  local($rpmname) = "";
  local(@LS_fileP) = ();

  &readFile($FILELIST,*LS_fileP);

  foreach $rpmname (@LS_fileP){
    $rpmname =~ s/^\s*//;
    $rpmname =~ s/\s*$//;

	if(!-e "./wbmc_rpm/$rpmname"){
  		print "No such file : $rpmname\n";
  		return 1;
	}

    if($rpmname eq "$APACHE_RPM"){
      if(-e "$HTTPDCONF"){ &ApacheInstall($rpmname)};
    }
    elsif($rpmname eq "$CRON_RPM" ){
      if(UpdateRPM($rpmname) == 0){
        if(-e "/etc/logrotate.d/cron.rpmsave"){
          system("/bin/mv /etc/logrotate.d/cron.rpmsave /etc/logrotate.d/cron > /dev/null 2>&1");
        }
      }
    }
    elsif($rpmname eq "$MODSSL_RPM"){
      $APACHE_RPM =~ /(.*)\..*\.rpm$/ ;
      $APACHE_VER = $1;
      if(!open(IN,"/bin/rpm -qq $APACHE_VER 2>&1 |")){
        print "Error Update.($rpmname)\n";
        return 1;
      }
      @code = <IN>;
      close(IN);
      UpdateRPM($rpmname);
    }
    elsif($rpmname eq "$MGETTY_RPM"){
      if(UpdateRPM($rpmname) == 0){
        if(-e "/etc/logrotate.d/mgetty.rpmsave"){
          system("/bin/mv /etc/logrotate.d/mgetty.rpmsave /etc/logrotate.d/mgetty > /dev/null 2>&1");
        }
      }
    }
    elsif($rpmname eq "$OPENLDAP_RPM"){
      if(UpdateRPM($rpmname) == 0){
        if(-e "/etc/openldap/slapd.conf.rpmnew"){
          system("/bin/rm /etc/openldap/slapd.conf.rpmnew > /dev/null 2>&1");
        }
      }
    }
    elsif($rpmname eq "$OPENSSH_C_RPM"){
      if(UpdateRPM($rpmname) == 0){
        if(-e "/etc/ssh/ssh_config.rpmnew"){
          system("/bin/rm /etc/ssh/ssh_config.rpmnew > /dev/null 2>&1");
        }
      }
    }
    elsif($rpmname eq "$OPENSSH_S_RPM"){
      if(UpdateRPM($rpmname) == 0){
        if(-e "/etc/ssh/sshd_config.rpmnew"){
          system("/bin/rm /etc/ssh/sshd_config.rpmnew > /dev/null 2>&1");
        }
      }
    }
    else{
      UpdateRPM($rpmname);

      if($rpmname eq "$SENDMAIL_RPM"){
        &REP_SendMailCF();
      }
    }
  }
}


sub UpdateRPM
{
  local($rpmname) = @_;
  local($shortname) = "";
  local(@code) = ();

  $shortname=Judg_RPM($rpmname);

  if(!open(IN,"/bin/rpm -qq $shortname 2>&1 |")){
    print "Update Failed.($rpmname)\n";
    return 1;
  }
  @code = <IN>;
  close(IN);

  if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
#    print "Package $rpmname is not installed.\n";
    return 0;
  }

  if(!open(IN,"/bin/rpm -F --nodeps --force ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
    print "Update Failed.($rpmname)\n";
    return 1;
  }
  close(IN);

  print "Update Successful.($rpmname)\n";
  return 0;
}

sub InstallRPM
{
  local($rpmname) = @_;
  if(!open(IN,"/bin/rpm -i ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
    print "Update Failed.($rpmname)\n";
    return 1;
  }
  close(IN);
  print "Update Successful.($rpmname)\n";
  return;
}

sub ApacheInstall
{
  local($rpmname) = @_;
  local($i,$j) = "";
  local(@HC_fileP,@RA_fileP,@HC_fileP,@code) = ();

	##==========================
	## ReadFile : $HTTPDCONF
	##==========================
	@HC_fileP=();
	&readFile($HTTPDCONF,*HC_fileP);

	foreach(@HC_fileP){
	  if(/^\s*\#/){
	    next;
	  }
	  elsif(/^\s*Timeout\s+(.+)\s+$/i){
	    $key{'TIMEOUT'}  = $1;
	  }
	  elsif(/^\s*MinSpareServers\s+(.+)\s+$/i){
	    $key{'MINSPARE'} = $1;
	  }
	  elsif(/^\s*MaxSpareServers\s+(.+)\s+$/i){
	    $key{'MAXSPARE'} = $1;
	  }
	  elsif(/^\s*StartServers\s+(.+)\s+$/i){
	    $key{'STARTS'} = $1;
	  }
	  elsif(/^\s*MaxClients\s+(.+)\s+$/i){
	    $key{'MAXCL'} = $1;
	  }
	  elsif(/^\s*User\s+(.+)\s+$/i){
	    $key{'USER'} = $1;
	  }
	  elsif(/^\s*Group\s+(.+)\s+$/i){
	    $key{'GROUP'} = $1;
	  }
	  elsif(/^\s*ServerName\s+(.+)\s+$/i){
	    $key{'SVNAME'} = $1;
	  }
	  elsif(/^\s*ServerAdmin\s+(.+)\s+$/i){
	    $key{'SVADMIN'} = $1;
	  }
	  elsif(/^\s*Include\s+(.+)\s+$/i){
	    push(@inc,"Include $1\n");
	  }
	  elsif(/^\s*Port\s+(.+)\s+$/i){
	    $key{'PORT'} = $1;
	  }
	}
#	if(!$key{"SVADMIN"}){
#	  $key{"SVADMIN"} = "web@".$key{"SVNAME"};
#	}

	##========================
	## Read : $ROTATE_APACHE
	##========================
	@RA_fileP=();
	&readFile($ROTATE_APACHE,*RA_fileP);

	##====================
	## Update : Apache
	##====================
	if(!open(IN,"/bin/rpm -qq httpd-2.0.46-44.ent 2>&1 |")){
	  print "Error Update.($rpmname)\n";
	  return;
	}
	@code = ();
	@code = <IN>;
	close(IN);

#	if($code[0] !~ /package\s+(.+)\s+is\s+not\s+installed/){
#	  print "Package $rpmname is already installed\n";
#	  return;
#	}
	if(!open(IN,"/bin/rpm -U --nodeps --force ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
	#    print "Failed to Update.($rpmname)\n";
	    return;
	}
	close(IN);

	system("/bin/chmod u-s /usr/sbin/suexec &> /dev/null");

	##================================
	## Substitution : $ROTATE_APACHE
	##================================
# 2004/12/21 oyama logrotate Խɬפʤ
#	&writeFile($ROTATE_APACHE,*RA_fileP);
	if(-e "$ROTATE_APACHE".".rpmsave"){
	  system("/bin/rm -rf $ROTATE_APACHE".".rpmsave");
	}
# 2004/12/21
# logrotate RHEL3 ɸ : /etc/logrotate.d/httpd,
# logrotate MW ɸ    : /etc/logrotate.d/apache
# ξ¸ߤȥơȴֳ֤Τ httpd 
	if(-e '/etc/logrotate.d/httpd') {
		unlink('/etc/logrotate.d/httpd');
	}

	##============================
	## Substitution : $HTTPDCONF
	##============================
	@HC_fileP=();
	&readFile($HTTPDCONF,*HC_fileP);

	for($i=0;$i<@HC_fileP;$i++){
	  if($HC_fileP[$i] =~ /^\s*\#/){
	    next;
	  }
	  elsif($HC_fileP[$i] =~ /^\s*Timeout\s+/i){
	    splice(@HC_fileP,$i,1,"Timeout $key{'TIMEOUT'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*MinSpareServers\s+/i){
	    splice(@HC_fileP,$i,1,"MinSpareServers $key{'MINSPARE'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*MaxSpareServers\s+/i){
	    splice(@HC_fileP,$i,1,"MaxSpareServers $key{'MAXSPARE'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*StartServers\s+/i){
	    splice(@HC_fileP,$i,1,"StartServers $key{'STARTS'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*MaxClients\s+/i){
	    splice(@HC_fileP,$i,1,"MaxClients $key{'MAXCL'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*User\s+/i){
	    splice(@HC_fileP,$i,1,"User $key{'USER'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*Group\s+/i){
	    splice(@HC_fileP,$i,1,"Group $key{'GROUP'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*ServerName\s+/i){
	    splice(@HC_fileP,$i,1,"ServerName $key{'SVNAME'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*ServerAdmin\s+/i){
	    splice(@HC_fileP,$i,1,"ServerAdmin $key{'SVADMIN'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^Listen\s*80\s+/i){
	    splice(@HC_fileP,$i,1,"#Listen 80\n");
	  }
	  elsif($HC_fileP[$i] =~ /^Listen\s*443\s+/i){
	    splice(@HC_fileP,$i,1,"#Listen 443\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*Port\s+/i){
	    splice(@HC_fileP,$i,1,"Port $key{'PORT'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*DocumentRoot\s+\"*\/home\/httpd\/html\"*/i) {
		$HC_fileP[$i] = "DocumentRoot \"/home/web/public_html\"\n";
	  }
	  elsif ($HC_fileP[$i] =~ /^\s*<\s*Directory\s+\"*\/home\/httpd\/html\"*\s*>/i) {
	    $HC_fileP[$i] = "<Directory \"/home/web/public_html\">\n";
	  }

	  elsif($HC_fileP[$i] =~ /^\s*Include\s+(.+)\s+$/i){
        for($j=0;$j<@inc;$j++){
		  if($HC_fileP[$i] eq $inc[$j]){
    	    splice(@inc,$j,1);
		    $j--;
		  }
		}
	  }

	}
	push(@HC_fileP,@inc);
#2004/12/21 oyama httpd.conf Խɬפʤ
#	&writeFile($HTTPDCONF,*HC_fileP);
	print "Update Successful.($rpmname)\n";

	return;
}

sub Judg_RPM
{
  local($rpmname) = @_;
  local(@code) = ();

  if(!open(IN,"/bin/rpm -qip ./wbmc_rpm/$rpmname |")){
    print "Update Failed. ($rpmname)\n";
    return "";
  }
  @code=<IN>;
  @ent = split(/\s+/,$code[0]);
  return ($ent[2]);

}

sub readFile
{
  local($filename,*fileP) = @_;
  open(IN,"$filename") || die "Can't open $filename. \n";
  @fileP = <IN>;
  close (IN);
}


sub writeFile
{
  local($filename,*fileP) = @_;
  open(OUT,"> $filename") || die "Can't open $filename. \n";
  print(OUT @fileP);
  close(OUT);
}


sub REP_SendMailCF
{
  local($filename) = "/etc/mail/sendmail.cf";
  local(@SMC_fileP,@ent) = ();
  local($i,$flg) = 0;
  local($data) = "";

  &readFile($filename,*SMC_fileP);
  for(;$i<@SMC_fileP;$i++){
    if($SMC_fileP[$i] =~ /^#/){ next;}
    if($SMC_fileP[$i] =~ /PrivacyOptions/){
      $flg = 1;
      @ent = split(/,/,$SMC_fileP[$i]);
      foreach $data (@ent){
        $data =~ s/^\s*//;
        $data =~ s/\s*$//;
        if($data eq "restrictqrun"){
          $flg = 2;
          last;
        }
      }
      if($flg == 1){
        $SMC_fileP[$i] =~ s/\s*$//;
        $SMC_fileP[$i] = "$SMC_fileP[$i]".",restrictqrun\n";
        splice(@SMC_fileP,$i,1,"$SMC_fileP[$i]");
      }
      last;
    }
  }
  if($flg == 0){
    print "No such Parameter PrivacyOptions : ($filename)\n";
    return 1;
  }elsif($flg == 1){
    &writeFile($filename,*SMC_fileP);
  }

  return 0;
}


